# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [1.0.0] - 2024-01-01

### Added
- Initial release with complete Laravel Process API implementation
- Core functionality:
  - Process execution with fluent interface
  - Process result handling and error management
  - Environment and working directory configuration
  - Input/output streaming and capture
  - TTY mode support
  - Timeout and idle timeout handling
- Process coordination:
  - Process pools for concurrent execution
  - Process piping for sequential execution
  - Pool result aggregation and error handling
- Testing utilities:
  - Process faking and recording
  - Fake process sequences
  - Process description builders
  - Test helpers and assertions
- Documentation:
  - Comprehensive API documentation
  - Usage examples
  - Testing guide
  - Contributing guidelines

### Changed
- N/A (initial release)

### Deprecated
- N/A (initial release)

### Removed
- N/A (initial release)

### Fixed
- N/A (initial release)

### Security
- N/A (initial release)

## [0.1.0] - 2023-12-15

### Added
- Initial development version
- Basic process execution functionality
- Early testing utilities
- Preliminary documentation

Note: This pre-release version was used for internal testing and development.
